/**
 * mr_biorhythm_chart.h
 *
 * A GTK+ widget that displays biorhythm
 * 
 * Authors:
 *   Salvador Cabrera  <salvadorcabrera@gmail.com>
 */

#ifndef __MR_BIORHYTHM_CHART_H__
#define __MR_BIORHYTHM_CHART_H__

#include <gtk/gtk.h>
#include "mr_utilities.h"

G_BEGIN_DECLS

#define MR_TYPE_BIORHYTHM_CHART		(mr_biorhythm_chart_get_type ())
#define MR_BIORHYTHM_CHART(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), MR_TYPE_BIORHYTHM_CHART, MrBiorhythmChart))
#define MR_BIORHYTHM_CHART_CLASS(obj)	(G_TYPE_CHECK_CLASS_CAST ((obj), MR_BIORHYTHM_CHART, MrBiorhythmChartClass))
#define MR_IS_BIORHYTHM_CHART(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), MR_TYPE_BIORHYTHM_CHART))
#define MR_IS_BIORHYTHM_CHART_CLASS(obj)	(G_TYPE_CHECK_CLASS_TYPE ((obj), MR_TYPE_BIORHYTHM_CHART))
#define MR_BIORHYTHM_CHART_GET_CLASS	(G_TYPE_INSTANCE_GET_CLASS ((obj), MR_TYPE_BIORHYTHM_CHART, MrBiorhythmChartClass))

typedef struct _MrBiorhythmChart		MrBiorhythmChart;
typedef struct _MrBiorhythmChartClass	MrBiorhythmChartClass;

struct _MrBiorhythmChart
{
	GtkDrawingArea parent;

	/* < private > */
};

struct _MrBiorhythmChartClass
{
	GtkDrawingAreaClass parent_class;
};

GtkWidget *mr_biorhythm_chart_new (void);
GType mr_biorhythm_chart_get_type    (void) G_GNUC_CONST;

G_END_DECLS




#endif
